#!/bin/bash
cd $(dirname "$BASH_SOURCE")/..
source config.cfg
#BATCHPATH=$(cd $(dirname "$BASH_SOURCE")/../software; pwd)
#This script assumes that ffmpeg and youtube-dl have been installed with paths defined already

mkdir -p $TEMPPATH
mkdir -p $DESTPATH

#VIDEO DEFINITIONS
ytsource="$1"
if [ "$2" = "Video" ]; then
	isvideo="1"
else
	isvideo="0"
fi
extraoptions="$3"

#FUNCTIONS
function getfilename() { #function to get filename of YouTube video
	youtube-dl $1 $2 --restrict-filenames --get-filename --merge-output-format mp4 -f "bestvideo[ext=mp4]+bestaudio[ext=m4a]" -o "%(title)s (%(uploader_id)s) %(resolution)s %(format_id)s [%(id)s].%(ext)s"
}

function downloadfile() { #function to download YouTube video
	youtube-dl $1 --restrict-filenames --no-overwrites --merge-output-format mp4 -f "bestvideo[ext=mp4]+bestaudio[ext=m4a]" -o "$2%(title)s (%(uploader_id)s) %(resolution)s %(format_id)s [%(id)s].%(ext)s" $3 $extraoptions 
}

#START
if [ "$isvideo" -eq "1" ]; then 
	videofilename=$(getfilename $ytsource "--no-playlist") #define videofilename
	if [ -n "$videofilename" ]; then #if video exists download video
		downloadfile $ytsource "$TEMPPATH/" "--no-playlist" 
		mv -i "$TEMPPATH/$videofilename" "$DESTPATH/$videofilename"
	else
		echo ""
		echo "File(s) not found!"
	fi
else #playlist
	PLFOLDER="Playlist_"$(date "+%Y%m%d-%Hh%Mm%Ss")
	mkdir -p "$TEMPPATH/$PLFOLDER"
	downloadfile $ytsource "$TEMPPATH/$PLFOLDER/"
	mv -i "$TEMPPATH/$PLFOLDER" "$DESTPATH" 
	echo ""
	echo "Playlist has been downloaded to: $DESTPATH/$PLFOLDER"
fi

osascript -e 'tell application "Terminal" to quit'
exit